DROP VIEW V_KUPCI_PLOVILA;

CREATE OR REPLACE VIEW V_KUPCI_PLOVILA (KUPCI_PLOVILA_ID, ID_LASTNIKA, KUPCI_IME, KUPCI_PRIIMEK, KUPCI_NASLOV, KUPCI_MESTO, KUPCI_POSTA, KUPCI_VRSTA, KUPCI_NDRZAVA, KUPCI_EMAIL, 
KUPCI_TELEFON_1, YACHT_CLUB_ID, KUPCI_ID_MEMBER, KUPCI_ACT, KUPCI_TELEX, KUPCI_GSM, KUPCI_TELEFON_2, KUPCI_DAVCNA_STEVILKA, KUPCI_VALUTA_PLACILA, KUPCI_SALDAKONTI_SIT, 
KUPCI_SALDAKONTI_DEM, KUPCI_SALDAKONTI_KOM, KUPCI_INT_CODE, KUPCI_VEHICLE_REGISTRATION_NUM, KUPCI_MANAGER, KUPCI_N_DOKUMENTA, OWNER, PLOVILA_ID, PLOVILA_IME, PLOVILA_REGISTRSKA_N, 
PLOVILA_MODEL, PLOVILA_NTIP, PLOVILA_NZASTAVA, TRENUTNO_OD, TRENUTNO_DO, POGODBA_DO, PLOVILA_DOLZINA, PLOVILA_SIRINA, PLOVILA_GREZ, PLOVILA_BOOKING, PLOVILA_ACT, PLOVILA_DATUM_ZAVAROVANJE, PLOVILA_ZAVAROVALNICA, 
PLOVILA_N_ZAVAROVALNE_POLICE, PLOVILA_ZAVAROVALNA_VSOTA, PLOVILA_PROIZVAJALEC, PLOVILA_TIP_PLOVILA, PLOVILA_NTIP_OPIS, PLOVILA_NZASTAVA_OPIS,
TRENUTNI_OBJEKT_PRIVEZA, TRENUTNA_N_PRIVEZA, TRENUTNA_KATEGORIJA, POGODBENI_OBJEKT_PRIVEZA, POGODBENA_N_PRIVEZA, POGODBENA_KATEGORIJA, KUPCI_MANAGER_USER, ID_PRIVEZ_TEMP, 
ID_LOCATION_TEMP, ID_PRIVEZ_CONTRACT, ID_LOCATION_CONTRACT, KUPCI_N_KK) AS 
  (
SELECT CONCAT(CONCAT(K.ID, '-'), P.ID) AS KUPCI_PLOVILA_ID, K.ID AS ID_LASTNIKA, K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK, K.NASLOV AS KUPCI_NASLOV, K.MESTO AS KUPCI_MESTO, K.POSTA AS KUPCI_POSTA, K.VRSTA AS KUPCI_VRSTA,
K.NDRZAVA AS KUPCI_NDRZAVA, K.EMAIL AS KUPCI_EMAIL, K.TELEFON_1 AS KUPCI_TELEFON_1, K.YACHT_CLUB_ID, K.ID_MEMBER AS KUPCI_ID_MEMBER, K.ACT AS KUPCI_ACT, K.TELEX AS KUPCI_TELEX, K.GSM AS KUPCI_GSM, K.TELEFON_2 AS KUPCI_TELEFON_2,
K.DAVCNA_STEVILKA AS KUPCI_DAVCNA_STEVILKA, K.VALUTA_PLACILA AS KUPCI_VALUTA_PLACILA, K.SALDAKONTI_SIT AS KUPCI_SALDAKONTI_SIT, K.SALDAKONTI_DEM AS KUPCI_SALDAKONTI_DEM, K.SALDAKONTI_KOM AS KUPCI_SALDAKONTI_KOM, K.INT_CODE AS KUPCI_INT_CODE,
K.VEHICLE_REGISTRATION_NUM AS KUPCI_VEHICLE_REGISTRATION_NUM, K.MANAGER AS KUPCI_MANAGER, K.N_DOKUMENTA AS KUPCI_N_DOKUMENTA,
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (K.IME || ' ' || K.PRIIMEK) ELSE (K.PRIIMEK || ' ' || K.IME) END) AS OWNER,
P.ID AS PLOVILA_ID, P.IME AS PLOVILA_IME, P.REGISTRSKA_N AS PLOVILA_REGISTRSKA_N, P.MODEL AS PLOVILA_MODEL, P.NTIP AS PLOVILA_NTIP, P.NZASTAVA AS PLOVILA_NZASTAVA, P.TRENUTNO_OD, P.TRENUTNO_DO, P.POGODBA_DO, P.DOLZINA AS PLOVILA_DOLZINA,
P.SIRINA AS PLOVILA_SIRINA, P.GREZ AS PLOVILA_GREZ, P.BOOKING AS PLOVILA_BOOKING, P.ACT AS PLOVILA_ACT, P.DATUM_ZAVAROVANJE AS PLOVILA_DATUM_ZAVAROVANJE, P.ZAVAROVALNICA AS PLOVILA_ZAVAROVALNICA, 
P.N_ZAVAROVALNE_POLICE AS PLOVILA_N_ZAVAROVALNE_POLICE, P.ZAVAROVALNA_VSOTA AS PLOVILA_ZAVAROVALNA_VSOTA, P.PROIZVAJALEC AS PLOVILA_PROIZVAJALEC, P.TIP_PLOVILA AS PLOVILA_TIP_PLOVILA, NNT.OPIS AS PLOVILA_NTIP_OPIS, NND.OPIS AS PLOVILA_NZASTAVA_OPIS,
CASE WHEN BERTH_TEMP.ID_PRIVEZ IS NOT NULL THEN BERTH_TEMP.OBJEKT ELSE P.TRENUTNI_OBJEKT_PRIVEZA END AS TRENUTNI_OBJEKT_PRIVEZA,
CASE WHEN BERTH_TEMP.ID_PRIVEZ IS NOT NULL THEN BERTH_TEMP.N_PRIVEZA ELSE P.TRENUTNA_N_PRIVEZA END AS TRENUTNA_N_PRIVEZA, BERTH_TEMP.KATEGORIJA AS TRENUTNA_KATEGORIJA,
CASE WHEN BERTH_CONTRACT.ID_PRIVEZ IS NOT NULL THEN BERTH_CONTRACT.OBJEKT ELSE P.POGODBENI_OBJEKT_PRIVEZA END AS POGODBENI_OBJEKT_PRIVEZA,
CASE WHEN BERTH_CONTRACT.ID_PRIVEZ IS NOT NULL THEN BERTH_CONTRACT.N_PRIVEZA ELSE P.POGODBENA_N_PRIVEZA END AS POGODBENA_N_PRIVEZA, BERTH_CONTRACT.KATEGORIJA AS POGODBENA_KATEGORIJA,
NNUSR.USER_ AS KUPCI_MANAGER_USER, VPT.ID_PRIVEZ AS ID_PRIVEZ_TEMP, VPT.NNLOCATION_ID AS ID_LOCATION_TEMP, VPC.ID_PRIVEZ AS ID_PRIVEZ_CONTRACT, VPC.NNLOCATION_ID AS ID_LOCATION_CONTRACT,
K.N_KK AS KUPCI_N_KK
FROM KUPCI K
LEFT OUTER JOIN PLOVILA P ON P.ID_LASTNIKA = K.ID
LEFT OUTER JOIN NUSER NNUSR ON K.MANAGER = NNUSR.NUSER
LEFT OUTER JOIN (SELECT PRIVEZI.*, RANK() OVER (PARTITION BY ID_PLOVILA ORDER BY ID_PRIVEZI ASC) RNK FROM PRIVEZI WHERE ID_POGODBE IS NULL) PRIVEZI_TEMP ON (PRIVEZI_TEMP.ID_PLOVILA = P.ID AND PRIVEZI_TEMP.RNK = 1)
LEFT OUTER JOIN NNPRIVEZ BERTH_TEMP ON BERTH_TEMP.ID_PRIVEZ = PRIVEZI_TEMP.ID_PRIVEZ
LEFT OUTER JOIN (SELECT PRIVEZI.*, RANK() OVER (PARTITION BY ID_PLOVILA ORDER BY ID_PRIVEZI DESC) RNK FROM PRIVEZI WHERE ID_POGODBE IS NOT NULL) PRIVEZI_CONTRACT ON (PRIVEZI_CONTRACT.ID_PLOVILA = P.ID AND PRIVEZI_CONTRACT.RNK = 1)
LEFT OUTER JOIN NNPRIVEZ BERTH_CONTRACT ON BERTH_CONTRACT.ID_PRIVEZ = PRIVEZI_CONTRACT.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPT ON VPT.ID_PRIVEZ = BERTH_TEMP.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPC ON VPC.ID_PRIVEZ = BERTH_CONTRACT.ID_PRIVEZ
LEFT OUTER JOIN NNTIP NNT ON NNT.SIFRA = P.NTIP
LEFT OUTER JOIN NNDRZAVE NND ON NND.SIFRA = P.NZASTAVA
)
;

DROP VIEW V_NNPRIKLJ
;

CREATE OR REPLACE VIEW V_NNPRIKLJ AS (
SELECT NN.NNPRIKLJ_ID, NPB.ID_PRIVEZ, NN.OZNAKA, NN.PRIKLJ, NN.ZACETNO_STANJE, NN.KONCNO_STANJE, NN.ZASEDEN, NN.INTERNI_OPIS, NN.OPIS, NN.EXT_DATE AS NNPRIKLJ_EXT_DATE, NN.EXT_PONTOON, NN.EXT_SOCKET, 
NN.VOLTAGE, NN.AMPERAGE, NN.EUUS, NN.METER_HW_VALUE, NN.EXT_ID, NN.STATUS, NN.SYSTEM_TYPE, NN.ACTIVE,
N.OPIS AS NPRIKLJ_OPIS, N.INTERNI_OPIS AS NPRIKLJ_INTERNI_OPIS, N.STORITEV AS NPRIKLJ_STORITEV, N.NPRIKLJ_TYPE AS NPRIKLJ_TYPE, N.STATE_CHECK AS NPRIKLJ_STATE_CHECK,
P.ID_PRIKLJ AS PRIKLJ_ID_PRIKLJ, P.ID_LASTNIKA AS PRIKLJ_ID_LASTNIKA, P.ID_PLOVILA AS PRIKLJ_ID_PLOVILA, P.ID AS PRIKLJ_ID, P.ID_STORITVE AS PRIKLJ_ID_STORITVE, P.OZNAKA AS PRIKLJ_OZNAKA, 
P.PRIKLJUCEK AS PRIKLJ_PRIKLJUCEK, P.DATUM_ZACETKA AS PRIKLJ_DATUM_ZACETKA, P.DATUM_KONCA AS PRIKLJ_DATUM_KONCA, P.ZACETNO_STANJE AS PRIKLJ_ZACETNO_STANJE, P.KONCNO_STANJE AS PRIKLJ_KONCNO_STANJE, 
P.ZASEDEN AS PRIKLJ_ZASEDEN, P.OBRACUNAN AS PRIKLJ_OBRACUNAN, P.STEVEC_HW_STANJE AS PRIKLJ_STEVEC_HW_STANJE,
NNP.OBJEKT AS NNPRIVEZ_OBJEKT, NNP.N_PRIVEZA AS NNPRIVEZ_N_PRIVEZA, NNP.KATEGORIJA AS NNPRIVEZ_KATEGORIJA, NNP.SORT_PRIKAZ AS NNPRIVEZ_SORT_PRIKAZ, NNPOM.SORT AS NNPOMOL_SORT,
K.PRIIMEK AS KUPCI_PRIIMEK, K.IME AS KUPCI_IME, PL.IME AS PLOVILA_IME, VPL.NNLOCATION_ID, VOL.OPIS AS VOLTAGE_OPIS, AMP.OPIS AS AMPERAGE_OPIS, EUS.OPIS AS EUUS_OPIS,
COALESCE(P.ZACETNO_STANJE, NN.ZACETNO_STANJE) AS PREVIOUS_STATE, NN.KONCNO_STANJE - COALESCE(P.ZACETNO_STANJE, NN.ZACETNO_STANJE) AS CONSUMPTION,
C.BRUTO_DOMACA_VALUTA AS PRICE_PER_UNIT, (NN.KONCNO_STANJE - COALESCE(P.ZACETNO_STANJE, NN.ZACETNO_STANJE))*C.BRUTO_DOMACA_VALUTA*COALESCE(N.METER_RATIO, 1) AS CONSUMPTION_PRICE
FROM NNPRIKLJ NN
JOIN (SELECT NNI.NNPRIKLJ_ID, CASE WHEN (NNI.ZASEDEN = 'Y') THEN (SELECT MAX(PI.ID_PRIKLJ) FROM PRIKLJ PI WHERE PI.NNPRIKLJ_ID=NNI.NNPRIKLJ_ID) ELSE NULL END AS PRIKLJ_ID FROM NNPRIKLJ NNI) NNI ON NNI.NNPRIKLJ_ID = NN.NNPRIKLJ_ID 
LEFT OUTER JOIN NPRIKLJ N ON NN.OZNAKA=N.SIFRA
LEFT OUTER JOIN NNPRIKLJ_BERTH NPB ON NN.NNPRIKLJ_ID=NPB.NNPRIKLJ_ID
LEFT OUTER JOIN NNPRIVEZ NNP ON NNP.ID_PRIVEZ = NPB.ID_PRIVEZ
LEFT OUTER JOIN NNPOMOL NNPOM ON NNPOM.SIFRA = NNP.KATEGORIJA
LEFT OUTER JOIN PRIKLJ P ON P.ID_PRIKLJ = NNI.PRIKLJ_ID
LEFT OUTER JOIN KUPCI K ON P.ID_LASTNIKA = K.ID
LEFT OUTER JOIN PLOVILA PL ON P.ID_PLOVILA = PL.ID
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPL ON VPL.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN NN_VOLTAGE VOL ON VOL.ID = NN.VOLTAGE
LEFT OUTER JOIN NN_AMPERAGE AMP ON AMP.ID = NN.AMPERAGE
LEFT OUTER JOIN NN_EUUS EUS ON EUS.ID = NN.EUUS
LEFT OUTER JOIN (SELECT M_NNCENMAR.*, RANK() OVER (PARTITION BY STORITEV ORDER BY ID_M_NNCENMAR DESC) RNK FROM M_NNCENMAR) C ON (C.STORITEV = N.STORITEV AND (C.NNLOCATION_ID IS NULL OR C.NNLOCATION_ID = NNPOM.NNLOCATION_ID) AND C.RNK = 1)
)
;

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (2015, SYSDATE, '5.5', 1935, 'V_KUPCI_PLOVILA')
;
