ALTER TABLE NCARD ADD TIME_FROM DATE;

ALTER TABLE NCARD ADD TIME_TO DATE;

UPDATE NCARD SET TIME_FROM = TO_DATE('00:00:01', 'HH24:MI:SS') WHERE TIME_FROM IS NULL;

UPDATE NCARD SET TIME_TO = TO_DATE('23:59:59', 'HH24:MI:SS') WHERE TIME_TO IS NULL;

DROP VIEW V_NCARD;

CREATE OR REPLACE VIEW V_NCARD AS (
SELECT N.NCARD, N.ID_LASTNIKA, N.ID_PLOVILA, N.VELJA_OD, N.VELJA_DO, N.SERIALNUMBER, N.NCARD_TYPE, N."COMMENT", N.STATUS, N.NNLOCATION_ID, N.RETURNED,
NCT.OPIS AS NCARD_TYPE_OPIS, NCT.INTERNI_OPIS AS NCARD_TYPE_INTERNI_OPIS, P.IME AS PLOVILA_IME, K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK, 
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (K.IME || ' ' || K.PRIIMEK) ELSE (K.PRIIMEK || ' ' || K.IME) END) AS OWNER,
(SELECT S.N_RACUNA FROM SALDKONT S WHERE S.NCARD = N.NCARD AND S.VRSTA_RACUNA IN ('POS', 'RAC') AND S.STORNO IS NULL AND ROWNUM <= 1) AS INVOICE_NUMBER,
(SELECT SUM(S.ZA_PLACILO) FROM SALDKONT S WHERE S.NCARD = N.NCARD AND S.VRSTA_RACUNA IN ('POS', 'RAC') AND (S.STORNO IS NULL OR S.STORNO <> 'D')) AS INVOICE_VALUE,
(SELECT SUM(S.ZA_PLACILO-S.PORABLJENO) FROM SALDKONT S WHERE S.NCARD = N.NCARD AND S.VRSTA_RACUNA IN (SELECT NK.SALDKONT FROM NKNJIZBA NK WHERE NK.DEPOSIT = 'Y')) AS DEPOSIT_VALUE,
(SELECT SUM(ABS(S.ZA_PLACILO)) FROM SALDKONT S WHERE S.NCARD = N.NCARD AND S.VRSTA_RACUNA IN (SELECT NK.SALDKONT FROM NKNJIZBA NK WHERE NK.REFUND = 'Y')) AS REFUND_VALUE,
NCT.CAMERA_ACCESS_CONTROL, N.TIME_FROM, N.TIME_TO
FROM NCARD N
LEFT OUTER JOIN NCARD_TYPE NCT ON NCT.ID = N.NCARD_TYPE
LEFT OUTER JOIN KUPCI K ON K.ID = N.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA P ON P.ID = N.ID_PLOVILA
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (2070, SYSDATE, '5.5', 1990, 'HIKVISION')
;