ALTER TABLE KONT_OSB_PLOVILA
ADD ODNOS VARCHAR2(3 CHAR);

ALTER TABLE KONT_OSB_PLOVILA
ADD NOTE VARCHAR2(2000 CHAR);

ALTER TABLE KONT_OSB_LASTNIK
ADD NOTE VARCHAR2(2000 CHAR);

CREATE TABLE NNODNOS_PLOVILA_KUPCI (
SIFRA VARCHAR2(3 CHAR) NOT NULL,
OPIS VARCHAR2(30 CHAR),
INTERNI_OPIS VARCHAR2(30 CHAR),
AKT VARCHAR2 (1 CHAR),
CONSTRAINT NNODNOS_PLOVILA_KUPCI_PK PRIMARY KEY(SIFRA)
);

INSERT INTO NNODNOS_PLOVILA_KUPCI VALUES ('CAP','Captain','Captain','Y');
INSERT INTO NNODNOS_PLOVILA_KUPCI VALUES ('CRW','Crew','Crew','Y');

ALTER TABLE KONT_OSB_PLOVILA 
ADD (ID_KONT_OSB_PLOVILA NUMBER);

CREATE SEQUENCE KONT_OSB_PLOVILA_SEQ MINVALUE 1 MAXVALUE 9999999999999999999999999999 INCREMENT BY 1 START WITH 1 CACHE 20 NOORDER  NOCYCLE;

UPDATE KONT_OSB_PLOVILA 
SET ID_KONT_OSB_PLOVILA = KONT_OSB_PLOVILA_SEQ.NEXTVAL
WHERE ID_KONT_OSB_PLOVILA IS NULL;

ALTER TABLE KONT_OSB_PLOVILA ADD (
CONSTRAINT KONT_OSB_PLOVILA_UNIQUE UNIQUE (ID_KONT_OSB_PLOVILA));

CREATE OR REPLACE
TRIGGER KONT_OSB_PLOVILA_TRG
BEFORE INSERT
ON KONT_OSB_PLOVILA
REFERENCING NEW AS NEW OLD AS OLD
FOR EACH ROW
BEGIN
	IF (:NEW.ID_KONT_OSB_PLOVILA IS NULL) THEN
          SELECT KONT_OSB_PLOVILA_SEQ.NEXTVAL INTO :NEW.ID_KONT_OSB_PLOVILA FROM DUAL;;
	END IF;;
END;;
;

CREATE OR REPLACE VIEW V_KONT_OSB_PLOVILA AS (
	SELECT P.ID_KONT_OSB_PLOVILA, P.ID_PLOVILA, P.ID_OSEBE, P.ODNOS, P.NOTE,
  NNPK.OPIS AS ODNOS_OPIS, NNPK.INTERNI_OPIS AS ODNOS_INTERNI_OPIS,
  KUPCI_OSEBA.PRIIMEK AS OSEBA_PRIIMEK, KUPCI_OSEBA.IME AS OSEBA_IME, KUPCI_OSEBA.NASLOV AS OSEBA_NASLOV, KUPCI_OSEBA.MESTO AS OSEBA_MESTO, KUPCI_OSEBA.POSTA AS OSEBA_POSTA
	FROM KONT_OSB_PLOVILA P
  LEFT OUTER JOIN KUPCI KUPCI_OSEBA ON P.ID_OSEBE = KUPCI_OSEBA.ID
  LEFT OUTER JOIN NNODNOS_PLOVILA_KUPCI NNPK ON P.ODNOS = NNPK.SIFRA
);

ALTER TABLE KONT_OSB_LASTNIK
ADD (ID_KONT_OSB_LASTNIK NUMBER);

CREATE SEQUENCE KONT_OSB_LASTNIK_SEQ MINVALUE 1 MAXVALUE 9999999999999999999999999999 INCREMENT BY 1 START WITH 1 CACHE 20 NOORDER  NOCYCLE;

UPDATE KONT_OSB_LASTNIK 
SET ID_KONT_OSB_LASTNIK = KONT_OSB_LASTNIK_SEQ.NEXTVAL
WHERE ID_KONT_OSB_LASTNIK IS NULL;

ALTER TABLE KONT_OSB_LASTNIK ADD (
CONSTRAINT KONT_OSB_LASTNIK_UNIQUE UNIQUE (ID_KONT_OSB_LASTNIK));

CREATE OR REPLACE
TRIGGER KONT_OSB_LASTNIK_TRG
BEFORE INSERT
ON KONT_OSB_LASTNIK
REFERENCING NEW AS NEW OLD AS OLD
FOR EACH ROW
BEGIN
	IF (:NEW.ID_KONT_OSB_LASTNIK IS NULL) THEN
          SELECT KONT_OSB_LASTNIK_SEQ.NEXTVAL INTO :NEW.ID_KONT_OSB_LASTNIK FROM DUAL;;
	END IF;;
END;;
;

CREATE OR REPLACE VIEW V_KONT_OSB_LASTNIK AS (
	SELECT K.ID_KONT_OSB_LASTNIK, K.ID_LASTNIKA, K.ID_OSEBE, K.ODNOS, K.DEPANDENT, K.HAS_MEMB_CARD, K.CAN_SIGN_INVOICE, K.CREW_ID, K.VELJA_DO, K.NOTE,
  NNODNOS.OPIS AS NNODNOS_OPIS, NNODNOS.INTERNI_OPIS AS NNODNOS_INTERNI_OPIS,
  KUPCI_LASTNIK.PRIIMEK AS LASTNIK_PRIIMEK, KUPCI_LASTNIK.IME AS LASTNIK_IME, KUPCI_LASTNIK.ID_MEMBER AS LASTNIK_ID_MEMBER, 
  KUPCI_LASTNIK.NASLOV AS LASTNIK_NASLOV, KUPCI_LASTNIK.MESTO AS LASTNIK_MESTO, KUPCI_LASTNIK.POSTA AS LASTNIK_POSTA,
  KUPCI_OSEBA.PRIIMEK AS OSEBA_PRIIMEK, KUPCI_OSEBA.IME AS OSEBA_IME, KUPCI_OSEBA.ID_MEMBER AS OSEBA_ID_MEMBER,
  KUPCI_OSEBA.NASLOV AS OSEBA_NASLOV, KUPCI_OSEBA.MESTO AS OSEBA_MESTO, KUPCI_OSEBA.POSTA AS OSEBA_POSTA
	FROM KONT_OSB_LASTNIK K
 	LEFT OUTER JOIN KUPCI KUPCI_LASTNIK ON K.ID_LASTNIKA = KUPCI_LASTNIK.ID
  LEFT OUTER JOIN KUPCI KUPCI_OSEBA ON K.ID_OSEBE = KUPCI_OSEBA.ID
  LEFT OUTER JOIN NNODNOS NNODNOS ON K.ODNOS = NNODNOS.SIFRA
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (642, SYSDATE, '5.5', 562, 'SP dodatki 2');