ALTER TABLE NDOGODEK ADD CONSTRAINT NDOGODEK_PK PRIMARY KEY (NDOGODEK);

CREATE TABLE EVENT_SITUATION (
	ID NUMBER NOT NULL,
	EVENT VARCHAR2(2 CHAR) NOT NULL,
	SITUATION NUMBER NOT NULL,
	ALARM VARCHAR2(1 CHAR),
	PREVENT_EXECUTION VARCHAR2(1 CHAR),
	ACT VARCHAR2(1 CHAR),
	CONSTRAINT ES_EVENT_FK FOREIGN KEY (EVENT) REFERENCES NDOGODEK(NDOGODEK),
	CONSTRAINT ES_SITUATION_FK FOREIGN KEY (SITUATION) REFERENCES NNSITUATION(ID),
	CONSTRAINT EVENT_SITUATION_PK PRIMARY KEY (ID)
);

ALTER TABLE EVENT_SITUATION
ADD CONSTRAINT EVENT_SITUATION_UNIQUE
UNIQUE (EVENT, SITUATION);

CREATE SEQUENCE EVENT_SITUATION_SEQ MINVALUE 1 MAXVALUE 9999999999999999999999999999 INCREMENT BY 1 START WITH 1 NOCACHE NOORDER  NOCYCLE;


CREATE OR REPLACE VIEW V_EVENT_SITUATION AS (
	SELECT ES.ID, ES.EVENT, ES.SITUATION, ES.ALARM, ES.PREVENT_EXECUTION, ES.ACT, ND.OPIS AS EVENT_OPIS, ND.INTERNI_OPIS AS EVENT_INTERNI_OPIS,
  NS.OPIS AS SITUATION_OPIS, NS.INTERNI_OPIS AS SITUATION_INTERNI_OPIS
	FROM EVENT_SITUATION ES
  LEFT OUTER JOIN NDOGODEK ND ON ND.NDOGODEK = ES.EVENT
  LEFT OUTER JOIN NNSITUATION NS ON NS.ID = ES.SITUATION
);

INSERT INTO EVENT_SITUATION(ID, EVENT, SITUATION, ALARM, PREVENT_EXECUTION, ACT)
SELECT EVENT_SITUATION_SEQ.NEXTVAL, 'OD', NS.ID, NS.ALARM, NULL, 'Y'
FROM NNSITUATION NS WHERE NS.AKT = 'Y';

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (780, SYSDATE, '5.5', 700, '673 popravek');