CREATE TABLE NNDATA_IMPORT (
ID NUMBER NOT NULL,
OPIS VARCHAR2(250 CHAR),
INTERNI_OPIS VARCHAR2(250 CHAR),
CONSTRAINT PK_NNDATA_IMPORT PRIMARY KEY (ID)
);

CREATE SEQUENCE NNDATA_IMPORT_SEQ MINVALUE 1 INCREMENT BY 1 START WITH 1000 NOCACHE NOORDER  NOCYCLE;

INSERT INTO NNDATA_IMPORT(ID, OPIS, INTERNI_OPIS) 
VALUES(1, 'Attachment reading', 'Attachment reading');

CREATE TABLE NNDATA_CATEGORY (
ID NUMBER NOT NULL,
OPIS VARCHAR2(250 CHAR),
INTERNI_OPIS VARCHAR2(250 CHAR),
CONSTRAINT PK_NNDATA_CATEGORY PRIMARY KEY (ID)
);

CREATE SEQUENCE NNDATA_CATEGORY_SEQ MINVALUE 1 INCREMENT BY 1 START WITH 1000 NOCACHE NOORDER  NOCYCLE;

INSERT INTO NNDATA_CATEGORY(ID, OPIS, INTERNI_OPIS) 
VALUES(1, 'Berth name', 'Berth name');

INSERT INTO NNDATA_CATEGORY(ID, OPIS, INTERNI_OPIS) 
VALUES(2, 'Power reading', 'Power reading');

INSERT INTO NNDATA_CATEGORY(ID, OPIS, INTERNI_OPIS) 
VALUES(3, 'Water reading', 'Water reading');

CREATE TABLE DATA_IMPORT_CATEGORY (
	ID NUMBER NOT NULL,
	ID_DATA_IMPORT NUMBER NOT NULL,
	ID_DATA_CATEGORY NUMBER NOT NULL,
	SORT NUMBER,
	CONSTRAINT DIC_DATA_IMPORT_FK FOREIGN KEY (ID_DATA_IMPORT) REFERENCES NNDATA_IMPORT(ID),
	CONSTRAINT DIC_DATA_CATEGORY_FK FOREIGN KEY (ID_DATA_CATEGORY) REFERENCES NNDATA_CATEGORY(ID),
	CONSTRAINT DATA_IMPORT_CATEGORY_PK PRIMARY KEY (ID)
);

CREATE SEQUENCE DATA_IMPORT_CATEGORY_SEQ MINVALUE 1 INCREMENT BY 1 START WITH 1 NOCACHE NOORDER  NOCYCLE;

ALTER TABLE DATA_IMPORT_CATEGORY
ADD CONSTRAINT DATA_IMPORT_CATEGORY_UNIQUE
UNIQUE (ID_DATA_IMPORT, ID_DATA_CATEGORY);

CREATE OR REPLACE VIEW V_DATA_IMPORT_CATEGORY AS (
SELECT DIC.ID, DIC.ID_DATA_IMPORT, DIC.ID_DATA_CATEGORY, DIC.SORT, DI.OPIS AS NNDATA_IMPORT_OPIS, DI.INTERNI_OPIS AS NNDATA_IMPORT_INTERNI_OPIS, 
DC.OPIS AS NNDATA_CATEGORY_OPIS, DC.INTERNI_OPIS AS NNDATA_CATEGORY_INTERNI_OPIS
FROM DATA_IMPORT_CATEGORY DIC
LEFT OUTER JOIN NNDATA_IMPORT DI ON DI.ID = DIC.ID_DATA_IMPORT
LEFT OUTER JOIN NNDATA_CATEGORY DC ON DC.ID = DIC.ID_DATA_CATEGORY
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (817, SYSDATE, '5.5', 737, 'Data import');